#include "psall.h"

/*

****************************************************************

     LPALL input forms:
                rescale            (GF)
                plot               (GF)
                profile            (GF)
                data columns       (GF)

                main
                zaxis

****************************************************************

*/

/* Hack to account for WM borders in window position */
#define WM_TITLEBAR_HEIGHT 21
#define WM_BORDER_WIDTH 4


set_in_wins()
{
int numwin,i,j,win;

        numwin = NUMWINS;
/*
        Settings Form definitions of inputwin structure
*/
        win = SETWIN;

        inputwin[win].xsize = 300;
        inputwin[win].ysize = 65;
        inputwin[win].num_inputs = 0;
        inputwin[win].num_lists = 0;
        inputwin[win].num_buttons = 3;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Settings");

        inputwin[win].num_inputs = 0;

        inputwin[win].num_buttons = 3;

                inputwin[win].buttons[0].row = 30;
                inputwin[win].buttons[0].col = 50;
                strcpy(inputwin[win].buttons[0].text,"Read");

                inputwin[win].buttons[1].row = 30;
                inputwin[win].buttons[1].col = 250;
                strcpy(inputwin[win].buttons[1].text,"Write");

                inputwin[win].buttons[2].row = 30;
                inputwin[win].buttons[2].col = 150;
                strcpy(inputwin[win].buttons[2].text,"Dismiss");

        inputwin[win].num_lists = 0;
/*
        Zaxis win definitions of inputwin structure
*/
        win = ZAXISWIN;

        inputwin[win].xsize = 580;
        inputwin[win].ysize = 450;
        inputwin[win].num_inputs = 9;
        inputwin[win].num_lists = 4;
        inputwin[win].num_buttons = 1;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Z Axis");

        inputwin[win].num_inputs = 10;

                inputwin[win].inputs[0].row = 50;
                inputwin[win].inputs[0].col = 170;
                inputwin[win].inputs[0].maxlen = 10;
                inputwin[win].inputs[0].disable = 0;
                inputwin[win].inputs[0].noedit = 0;
                strcpy(inputwin[win].inputs[0].def,"");
                strcpy(inputwin[win].inputs[0].caption,"Maximum Z value =");

                inputwin[win].inputs[1].row = 50;
                inputwin[win].inputs[1].col = 430;
                inputwin[win].inputs[1].maxlen = 10;
                inputwin[win].inputs[1].disable = 0;
                inputwin[win].inputs[1].noedit = 0;
                strcpy(inputwin[win].inputs[1].def,"");
                strcpy(inputwin[win].inputs[1].caption,"Minimum Z value =");

                inputwin[win].inputs[2].row = 100;
                inputwin[win].inputs[2].col = 330;
                inputwin[win].inputs[2].maxlen = 10;
                inputwin[win].inputs[2].disable = 0;
                inputwin[win].inputs[2].noedit = 0;
                strcpy(inputwin[win].inputs[2].def,"");
                strcpy(inputwin[win].inputs[2].caption,"Step for Z scale");

                inputwin[win].inputs[3].row = 150;
                inputwin[win].inputs[3].col = 450;
                inputwin[win].inputs[3].maxlen = 10;
                inputwin[win].inputs[3].disable = 0;
                inputwin[win].inputs[3].noedit = 0;
                strcpy(inputwin[win].inputs[3].def,"");
                strcpy(inputwin[win].inputs[3].caption,"Z null");

                inputwin[win].inputs[4].row = 150;
                inputwin[win].inputs[4].col = 270;
                inputwin[win].inputs[4].maxlen = 10;
                inputwin[win].inputs[4].disable = 0;
                inputwin[win].inputs[4].noedit = 0;
                strcpy(inputwin[win].inputs[4].def,"");
                strcpy(inputwin[win].inputs[4].caption,"value");

                inputwin[win].inputs[5].row = 250;
                inputwin[win].inputs[5].col = 160;
                inputwin[win].inputs[5].maxlen = 10;
                inputwin[win].inputs[5].disable = 0;
                inputwin[win].inputs[5].noedit = 0;
                strcpy(inputwin[win].inputs[5].def,"");
                strcpy(inputwin[win].inputs[5].caption,"Max X location =");

                inputwin[win].inputs[6].row = 280;
                inputwin[win].inputs[6].col = 160;
                inputwin[win].inputs[6].maxlen = 10;
                inputwin[win].inputs[6].disable = 0;
                inputwin[win].inputs[6].noedit = 0;
                strcpy(inputwin[win].inputs[6].def,"");
                strcpy(inputwin[win].inputs[6].caption,"Min X location =");

                inputwin[win].inputs[7].row = 250;
                inputwin[win].inputs[7].col = 420;
                inputwin[win].inputs[7].maxlen = 10;
                inputwin[win].inputs[7].disable = 0;
                inputwin[win].inputs[7].noedit = 0;
                strcpy(inputwin[win].inputs[7].def,"");
                strcpy(inputwin[win].inputs[7].caption,"Max Y location =");

                inputwin[win].inputs[8].row = 280;
                inputwin[win].inputs[8].col = 420;
                inputwin[win].inputs[8].maxlen = 10;
                inputwin[win].inputs[8].disable = 0;
                inputwin[win].inputs[8].noedit = 0;
                strcpy(inputwin[win].inputs[8].def,"");
                strcpy(inputwin[win].inputs[8].caption,"Min Y location =");

                inputwin[win].inputs[9].row = 330;
                inputwin[win].inputs[9].col = 160;
                inputwin[win].inputs[9].maxlen = 40;
                inputwin[win].inputs[9].disable = 0;
                inputwin[win].inputs[9].noedit = 0;
                strcpy(inputwin[win].inputs[9].def,"");
                strcpy(inputwin[win].inputs[9].caption,"Z axis label");

        inputwin[win].num_buttons = 1;

                inputwin[win].buttons[0].row = 420;
                inputwin[win].buttons[0].col = 300;
                inputwin[win].buttons[0].disable  = 0;
                strcpy(inputwin[win].buttons[0].text,"Accept");

        inputwin[win].num_lists = 6;

                inputwin[win].lists[0].row = 100;
                inputwin[win].lists[0].col = 130;
                inputwin[win].lists[0].maxlen = 1;
                inputwin[win].lists[0].disable = 0;
                inputwin[win].lists[0].numeric = 0;
                inputwin[win].lists[0].def = 1;
                strcpy(inputwin[win].lists[0].caption,"Show Z scale");

                inputwin[win].lists[0].list_len = 2;
                        strcpy(inputwin[win].lists[0].text[0],"N");
                        strcpy(inputwin[win].lists[0].text[1],"Y");

                inputwin[win].lists[1].row = 150;
                inputwin[win].lists[1].col = 130;
                inputwin[win].lists[1].maxlen = 6;
                inputwin[win].lists[1].disable = 0;
                inputwin[win].lists[1].numeric = 0;
                inputwin[win].lists[1].def = 0;
                strcpy(inputwin[win].lists[1].caption,"Null color");

                inputwin[win].lists[1].list_len = 2;
                        strcpy(inputwin[win].lists[1].text[0],"white");
                        strcpy(inputwin[win].lists[1].text[1],"value");

                inputwin[win].lists[2].row = 200;
                inputwin[win].lists[2].col = 150;
                inputwin[win].lists[2].maxlen = 47;
                inputwin[win].lists[2].disable = 0;
                inputwin[win].lists[2].numeric = 0;
                inputwin[win].lists[2].def = 2;
                strcpy(inputwin[win].lists[2].caption,"Colormap");

                inputwin[win].lists[2].list_len = 11;
                        strcpy(inputwin[win].lists[2].text[0],"gray scale");
                        strcpy(inputwin[win].lists[2].text[1],"shades: blue green red");
                        strcpy(inputwin[win].lists[2].text[2],"shades: blue yellow white");
                        strcpy(inputwin[win].lists[2].text[3],"edges: blue cyan green yellow red");
                        strcpy(inputwin[win].lists[2].text[4],"edges: magenta blue cyan green yellow red");
                        strcpy(inputwin[win].lists[2].text[5],"steps: magenta blue cyan green yellow red");
                        strcpy(inputwin[win].lists[2].text[6],"NTSC shades: blue green red");
                        strcpy(inputwin[win].lists[2].text[7],"NTSC shades: blue yellow white");
                        strcpy(inputwin[win].lists[2].text[8],"NTSC edges: blue cyan green yellow red");
                        strcpy(inputwin[win].lists[2].text[9],"NTSC edges: magenta blue cyan green yellow red");
                        strcpy(inputwin[win].lists[2].text[10],"NTSC steps: magenta blue cyan green yellow red");

                inputwin[win].lists[3].row = 370;
                inputwin[win].lists[3].col = 450;
                inputwin[win].lists[3].maxlen = 1;
                inputwin[win].lists[3].disable = 0;
                inputwin[win].lists[3].numeric = 0;
                inputwin[win].lists[3].def = 1;
                strcpy(inputwin[win].lists[3].caption,"Preserve Aspect");

                inputwin[win].lists[3].list_len = 2;
                        strcpy(inputwin[win].lists[3].text[0],"N");
                        strcpy(inputwin[win].lists[3].text[1],"Y");

                inputwin[win].lists[4].row = 100;
                inputwin[win].lists[4].col = 530;
                inputwin[win].lists[4].maxlen = 1;
                inputwin[win].lists[4].disable = 0;
                inputwin[win].lists[4].numeric = 0;
                inputwin[win].lists[4].def = 0;
                strcpy(inputwin[win].lists[4].caption,"Log Z");

                inputwin[win].lists[4].list_len = 2;
                        strcpy(inputwin[win].lists[4].text[0],"N");
                        strcpy(inputwin[win].lists[4].text[1],"Y");

                inputwin[win].lists[5].row = 370;
                inputwin[win].lists[5].col = 250;
                inputwin[win].lists[5].maxlen = 2;
                inputwin[win].lists[5].disable = 0;
                inputwin[win].lists[5].numeric = 1;
                inputwin[win].lists[5].def = 5;
                strcpy(inputwin[win].lists[5].caption,"Z scale format num digits");

                inputwin[win].lists[5].list_len = 10;

/*
        Main Window  definitions of inputwin structure
*/
        win = MAINWIN;

        inputwin[win].xsize = 564;
        inputwin[win].ysize = 400;
        inputwin[win].num_inputs = 4;
        inputwin[win].num_lists = 2;
        inputwin[win].num_buttons = 6;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"PS ALL");

        inputwin[win].num_inputs = 4;

                inputwin[win].inputs[0].row = 50;
                inputwin[win].inputs[0].col = 175;
                inputwin[win].inputs[0].maxlen = 30;
                strcpy(inputwin[win].inputs[0].def,"");
                strcpy(inputwin[win].inputs[0].caption,"GF filename");

                inputwin[win].inputs[1].row = 100;
                inputwin[win].inputs[1].col = 175;
                inputwin[win].inputs[1].maxlen = 30;
                strcpy(inputwin[win].inputs[1].def,"");
                strcpy(inputwin[win].inputs[1].caption,"Raster filename");

                inputwin[win].inputs[2].row = 150;
                inputwin[win].inputs[2].col = 175;
                inputwin[win].inputs[2].maxlen = 30;
                strcpy(inputwin[win].inputs[2].def,"");
                strcpy(inputwin[win].inputs[2].caption,"to");

                inputwin[win].inputs[3].row = 216;
                inputwin[win].inputs[3].col = 173;
                inputwin[win].inputs[3].maxlen = 30;
                strcpy(inputwin[win].inputs[3].def,"");
                strcpy(inputwin[win].inputs[3].caption,"Settings filename");

        inputwin[win].num_buttons = 6;

                inputwin[win].buttons[0].row = 350;
                inputwin[win].buttons[0].col = 500;
                strcpy(inputwin[win].buttons[0].text,"Quit");

                inputwin[win].buttons[1].row = 350;
                inputwin[win].buttons[1].col = 150;
                strcpy(inputwin[win].buttons[1].text,"Rescale");

                inputwin[win].buttons[2].row = 350;
                inputwin[win].buttons[2].col = 50;
                strcpy(inputwin[win].buttons[2].text,"Plot");

                inputwin[win].buttons[3].row = 350;
                inputwin[win].buttons[3].col = 250;
                strcpy(inputwin[win].buttons[3].text,"Z axis");

                inputwin[win].buttons[4].row = 350;
                inputwin[win].buttons[4].col = 350;
                strcpy(inputwin[win].buttons[4].text,"Profile");

                inputwin[win].buttons[5].row = 210;
                inputwin[win].buttons[5].col = 490;
                strcpy(inputwin[win].buttons[5].text,"R/W");

        inputwin[win].num_lists = 3;

                inputwin[win].lists[0].row = 100;
                inputwin[win].lists[0].col = 490;
                inputwin[win].lists[0].maxlen = 4;
                inputwin[win].lists[0].def = 0;
                strcpy(inputwin[win].lists[0].caption,"type");

#ifdef SGI
                inputwin[win].lists[0].list_len = 5;
#else
                inputwin[win].lists[0].list_len = 4;
#endif
                        strcpy(inputwin[win].lists[0].text[0],"auto");
                        strcpy(inputwin[win].lists[0].text[1],"CP");
                        strcpy(inputwin[win].lists[0].text[2],"IMG");
                        strcpy(inputwin[win].lists[0].text[3],"CMP");
                        strcpy(inputwin[win].lists[0].text[4],"SGI");

                inputwin[win].lists[1].row = 150;
                inputwin[win].lists[1].col = 90;
                inputwin[win].lists[1].maxlen = 1;
                inputwin[win].lists[1].def = 0;
                strcpy(inputwin[win].lists[1].caption,"Fade");

                inputwin[win].lists[1].list_len = 2;
                        strcpy(inputwin[win].lists[1].text[0],"N");
                        strcpy(inputwin[win].lists[1].text[1],"Y");

                inputwin[win].lists[2].row = 150;
                inputwin[win].lists[2].col = 490;
                inputwin[win].lists[2].maxlen = 2;
                inputwin[win].lists[2].numeric = 1;
                inputwin[win].lists[2].def = 10;
                strcpy(inputwin[win].lists[2].caption,"steps");

                inputwin[win].lists[2].list_len = 50;
/*
        Rescale window definitions of inputwin structure
*/
        win = RESCALEWIN;

        inputwin[win].xsize = 550;

        inputwin[win].ysize = 400;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Rescale");

        inputwin[win].num_inputs = 8;

                inputwin[win].inputs[0].row = 50;
                inputwin[win].inputs[0].col = 175;
                inputwin[win].inputs[0].maxlen = 10;
                strcpy(inputwin[win].inputs[0].def,"1");
                strcpy(inputwin[win].inputs[0].caption,"Maximum X value = ");

                inputwin[win].inputs[1].row = 80;
                inputwin[win].inputs[1].col = 175;
                inputwin[win].inputs[1].maxlen = 10;
                strcpy(inputwin[win].inputs[1].def,"0");
                strcpy(inputwin[win].inputs[1].caption,"Minimum X value = ");

                inputwin[win].inputs[2].row = 50;
                inputwin[win].inputs[2].col = 450;
                inputwin[win].inputs[2].maxlen = 10;
                strcpy(inputwin[win].inputs[2].def,"1");
                strcpy(inputwin[win].inputs[2].caption,"Maximum Y value = ");

                inputwin[win].inputs[3].row = 80;
                inputwin[win].inputs[3].col = 450;
                inputwin[win].inputs[3].maxlen = 10;
                strcpy(inputwin[win].inputs[3].def,"0");
                strcpy(inputwin[win].inputs[3].caption,"Minimum Y value = ");

                inputwin[win].inputs[4].row = 180;
                inputwin[win].inputs[4].col = 125;
                inputwin[win].inputs[4].maxlen = 50;
                strcpy(inputwin[win].inputs[4].def,"x axis");
                strcpy(inputwin[win].inputs[4].caption,"X axis label");

                inputwin[win].inputs[5].row = 210;
                inputwin[win].inputs[5].col = 125;
                inputwin[win].inputs[5].maxlen = 50;
                strcpy(inputwin[win].inputs[5].def,"y axis");
                strcpy(inputwin[win].inputs[5].caption,"Y axis label");

                inputwin[win].inputs[6].row = 280;
                inputwin[win].inputs[6].col = 175;
                inputwin[win].inputs[6].maxlen = 10;
                strcpy(inputwin[win].inputs[6].def,".1");
                strcpy(inputwin[win].inputs[6].caption,"X tick/grid step");

                inputwin[win].inputs[7].row = 280;
                inputwin[win].inputs[7].col = 450;
                inputwin[win].inputs[7].maxlen = 10;
                strcpy(inputwin[win].inputs[7].def,".1");
                strcpy(inputwin[win].inputs[7].caption,"Y tick/grid step");

        inputwin[win].num_buttons = 3;

                inputwin[win].buttons[0].row = 350;
                inputwin[win].buttons[0].col = 100;
                strcpy(inputwin[win].buttons[0].text,"Apply");

                inputwin[win].buttons[1].row = 350;
                inputwin[win].buttons[1].col = 450;
                strcpy(inputwin[win].buttons[1].text,"Accept");

                inputwin[win].buttons[2].row = 350;
                inputwin[win].buttons[2].col = 275;
                strcpy(inputwin[win].buttons[2].text,"Auto");

        inputwin[win].num_lists = 3;

                inputwin[win].lists[0].row = 130;
                inputwin[win].lists[0].col = 175;
                inputwin[win].lists[0].maxlen = 6;
                inputwin[win].lists[0].def = 0;
                strcpy(inputwin[win].lists[0].caption,"X Scaling");

                inputwin[win].lists[0].list_len = 2;
                        strcpy(inputwin[win].lists[0].text[0],"linear");
                        strcpy(inputwin[win].lists[0].text[1],"log");

                inputwin[win].lists[1].row = 130;
                inputwin[win].lists[1].col = 450;
                inputwin[win].lists[1].maxlen = 6;
                inputwin[win].lists[1].def = 0;
                strcpy(inputwin[win].lists[1].caption,"Y Scaling");

                inputwin[win].lists[1].list_len = 2;
                        strcpy(inputwin[win].lists[1].text[0],"linear");
                        strcpy(inputwin[win].lists[1].text[1],"log");

                inputwin[win].lists[2].row = 250;
                inputwin[win].lists[2].col = 300;
                inputwin[win].lists[2].maxlen = 5;
                inputwin[win].lists[2].def = 0;
                strcpy(inputwin[win].lists[2].caption,"Ticks/Grids");

                inputwin[win].lists[2].list_len = 3;
                        strcpy(inputwin[win].lists[2].text[0],"none");
                        strcpy(inputwin[win].lists[2].text[1],"ticks");
                        strcpy(inputwin[win].lists[2].text[2],"grids");

/************************

        PLOT window definitions of inputwin structure

***********************************/

        win = PLOTWIN;

        inputwin[win].xsize = 510;
        inputwin[win].ysize = 540;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Plot");

        inputwin[win].num_inputs = 4;

                inputwin[win].inputs[0].row = 40;
                inputwin[win].inputs[0].col = 125;
                inputwin[win].inputs[0].maxlen = 40;
                strcpy(inputwin[win].inputs[0].def,"gfxplot");
                strcpy(inputwin[win].inputs[0].caption,"Plot Filename");

                inputwin[win].inputs[1].row = 120;
                inputwin[win].inputs[1].col = 400;
                inputwin[win].inputs[1].maxlen = 5;
                strcpy(inputwin[win].inputs[1].def,"1.");
                strcpy(inputwin[win].inputs[1].caption,"Text size");

                inputwin[win].inputs[2].row = 160;
                inputwin[win].inputs[2].col = 175;
                inputwin[win].inputs[2].maxlen = 5;
                strcpy(inputwin[win].inputs[2].def,"5.");
                strcpy(inputwin[win].inputs[2].caption,"X axis length (in)");

                inputwin[win].inputs[3].row = 160;
                inputwin[win].inputs[3].col = 400;
                inputwin[win].inputs[3].maxlen = 5;
                inputwin[win].inputs[3].disable = 1; /* aspect is fixed 1:1 */
                strcpy(inputwin[win].inputs[3].def,"4.");
                strcpy(inputwin[win].inputs[3].caption,"Y axis length (in)");

        inputwin[win].num_buttons = 2;

                inputwin[win].buttons[0].row = 490;
                inputwin[win].buttons[0].col = 125;
                strcpy(inputwin[win].buttons[0].text,"Plot");

                inputwin[win].buttons[1].row = 490;
                inputwin[win].buttons[1].col = 350;
                strcpy(inputwin[win].buttons[1].text,"Dismiss");

        inputwin[win].num_lists = 15;

                inputwin[win].lists[0].row = 80;
                inputwin[win].lists[0].col = 125;
                inputwin[win].lists[0].maxlen = 10;
                inputwin[win].lists[0].def = 0;
                inputwin[win].lists[0].disable = 0;  /* can only do ps */
                strcpy(inputwin[win].lists[0].caption,"Output as");

                inputwin[win].lists[0].list_len = 2; /* dump HPGL */
                        strcpy(inputwin[win].lists[0].text[0],"Postscript");
                        strcpy(inputwin[win].lists[0].text[1],"Encap PS");
                        strcpy(inputwin[win].lists[0].text[2],"HPGL");

                inputwin[win].lists[1].row = 120;
                inputwin[win].lists[1].col = 125;
                inputwin[win].lists[1].maxlen = 10;
                inputwin[win].lists[1].def = 0;
                strcpy(inputwin[win].lists[1].caption,"Orientation");

                inputwin[win].lists[1].list_len = 2;
                        strcpy(inputwin[win].lists[1].text[0],"Portrait");
                        strcpy(inputwin[win].lists[1].text[1],"Landscape");

                inputwin[win].lists[2].row = 200;
                inputwin[win].lists[2].col = 110;
                inputwin[win].lists[2].maxlen = 3;
                inputwin[win].lists[2].def = 1;
                strcpy(inputwin[win].lists[2].caption,"Plot Axes");

                inputwin[win].lists[2].list_len = 2;
                        strcpy(inputwin[win].lists[2].text[0],"No");
                        strcpy(inputwin[win].lists[2].text[1],"Yes");

                inputwin[win].lists[3].row = 200;
                inputwin[win].lists[3].col = 250;
                inputwin[win].lists[3].maxlen = 3;
                inputwin[win].lists[3].def = 1;
                strcpy(inputwin[win].lists[3].caption,"Comments");

                inputwin[win].lists[3].list_len = 2;
                        strcpy(inputwin[win].lists[3].text[0],"No");
                        strcpy(inputwin[win].lists[3].text[1],"Yes");

                inputwin[win].lists[4].row = 200;
                inputwin[win].lists[4].col = 380;
                inputwin[win].lists[4].maxlen = 3;
                inputwin[win].lists[4].def = 1;
                strcpy(inputwin[win].lists[4].caption,"Curve");

                inputwin[win].lists[4].list_len = 2;
                        strcpy(inputwin[win].lists[4].text[0],"No");
                        strcpy(inputwin[win].lists[4].text[1],"Yes");

                inputwin[win].lists[5].row = 250;
                inputwin[win].lists[5].col = 130;
                inputwin[win].lists[5].maxlen = 2;
                inputwin[win].lists[5].def = 0;
                strcpy(inputwin[win].lists[5].caption,"Data Segment:");

                inputwin[win].lists[5].list_len = 1;  /* set dynamically */
                inputwin[win].lists[5].numeric = 1; /* auto numbering, don't
                                                                need below */

                inputwin[win].lists[6].row = 250;
                inputwin[win].lists[6].col = 230;
                inputwin[win].lists[6].maxlen = 7;
                inputwin[win].lists[6].def = 0;
                strcpy(inputwin[win].lists[6].caption,"Color");

                inputwin[win].lists[6].list_len = 8;
                        strcpy(inputwin[win].lists[6].text[0],"black");
                        strcpy(inputwin[win].lists[6].text[1],"blue");
                        strcpy(inputwin[win].lists[6].text[2],"green");
                        strcpy(inputwin[win].lists[6].text[3],"red");
                        strcpy(inputwin[win].lists[6].text[4],"cyan");
                        strcpy(inputwin[win].lists[6].text[5],"magenta");
                        strcpy(inputwin[win].lists[6].text[6],"brown");
                        strcpy(inputwin[win].lists[6].text[7],"white");

                inputwin[win].lists[7].row = 250;
                inputwin[win].lists[7].col = 410;
                inputwin[win].lists[7].maxlen = 2;
                inputwin[win].lists[7].def = 1;
                strcpy(inputwin[win].lists[7].caption,"Width");

                inputwin[win].lists[7].list_len = 6;
                        strcpy(inputwin[win].lists[7].text[0],"28");
                        strcpy(inputwin[win].lists[7].text[1],"12");
                        strcpy(inputwin[win].lists[7].text[2],"18");
                        strcpy(inputwin[win].lists[7].text[3],"6");
                        strcpy(inputwin[win].lists[7].text[4],"3");
                        strcpy(inputwin[win].lists[7].text[5],"36");

                inputwin[win].lists[8].row = 300;
                inputwin[win].lists[8].col = 230;
                inputwin[win].lists[8].maxlen = 10;
                inputwin[win].lists[8].def = 0;
                strcpy(inputwin[win].lists[8].caption,"Pattern");

                inputwin[win].lists[8].list_len = 7;
                        strcpy(inputwin[win].lists[8].text[0],"solid");
                        strcpy(inputwin[win].lists[8].text[1],"dot-dash");
                        strcpy(inputwin[win].lists[8].text[2],"dash-dash");
                        strcpy(inputwin[win].lists[8].text[3],"long-short");
                        strcpy(inputwin[win].lists[8].text[4],"l-s-dot-s");
                        strcpy(inputwin[win].lists[8].text[5],"l-s-s-s");
                        strcpy(inputwin[win].lists[8].text[6],"l-s-s-s-s");

                inputwin[win].lists[9].row = 300;
                inputwin[win].lists[9].col = 410;
                inputwin[win].lists[9].maxlen = 2;
                inputwin[win].lists[9].def = 3;
                strcpy(inputwin[win].lists[9].caption,"Length");

                inputwin[win].lists[9].list_len = 8;
                        strcpy(inputwin[win].lists[9].text[0],"1");
                        strcpy(inputwin[win].lists[9].text[1],"2");
                        strcpy(inputwin[win].lists[9].text[2],"3");
                        strcpy(inputwin[win].lists[9].text[3],"4");
                        strcpy(inputwin[win].lists[9].text[4],"5");
                        strcpy(inputwin[win].lists[9].text[5],"6");
                        strcpy(inputwin[win].lists[9].text[6],"7");
                        strcpy(inputwin[win].lists[9].text[7],"8");

                inputwin[win].lists[10].row = 350;
                inputwin[win].lists[10].col = 70;
                inputwin[win].lists[10].maxlen = 20;
                inputwin[win].lists[10].def = 0;
                strcpy(inputwin[win].lists[10].caption,"Text:");

                inputwin[win].lists[10].list_len = 1;
                        strcpy(inputwin[win].lists[10].text[0],"Axes labels");
                        /* rest are dynamically filled with caption text
                        strcpy(inputwin[win].lists[10].text[1],"");
                        strcpy(inputwin[win].lists[10].text[2],"");
                        strcpy(inputwin[win].lists[10].text[3],"");
                        strcpy(inputwin[win].lists[10].text[4],"");
                        strcpy(inputwin[win].lists[10].text[5],"");
                        strcpy(inputwin[win].lists[10].text[6],"");
                        strcpy(inputwin[win].lists[10].text[7],"");
                        strcpy(inputwin[win].lists[10].text[8],"");
                        */

                inputwin[win].lists[11].row = 350;
                inputwin[win].lists[11].col = 310;
                inputwin[win].lists[11].maxlen = 20;
                inputwin[win].lists[11].def = 1;
                strcpy(inputwin[win].lists[11].caption,"Font");

                inputwin[win].lists[11].list_len = 9;
                        strcpy(inputwin[win].lists[11].text[0],"Helvetica-Bold");
                        strcpy(inputwin[win].lists[11].text[1],"Helvetica");
                        strcpy(inputwin[win].lists[11].text[2],"Helvetica-BoldOblique");
                        strcpy(inputwin[win].lists[11].text[3],"Times-Roman");
                        strcpy(inputwin[win].lists[11].text[4],"Times-Bold");
                        strcpy(inputwin[win].lists[11].text[5],"Times-Italic");
                        strcpy(inputwin[win].lists[11].text[6],"Symbol");
                        strcpy(inputwin[win].lists[11].text[7],"Palatino-Roman");
                        strcpy(inputwin[win].lists[11].text[8],"Palatino-Bold");

                inputwin[win].lists[12].row = 390;
                inputwin[win].lists[12].col = 310;
                inputwin[win].lists[12].maxlen = 7;
                inputwin[win].lists[12].def = 0;
                strcpy(inputwin[win].lists[12].caption,"Color");

                inputwin[win].lists[12].list_len = 8;
                        strcpy(inputwin[win].lists[12].text[0],"black");
                        strcpy(inputwin[win].lists[12].text[1],"blue");
                        strcpy(inputwin[win].lists[12].text[2],"green");
                        strcpy(inputwin[win].lists[12].text[3],"red");
                        strcpy(inputwin[win].lists[12].text[4],"cyan");
                        strcpy(inputwin[win].lists[12].text[5],"magenta");
                        strcpy(inputwin[win].lists[12].text[6],"brown");
                        strcpy(inputwin[win].lists[12].text[7],"white");

                inputwin[win].lists[13].row = 430;
                inputwin[win].lists[13].col = 230;
                inputwin[win].lists[13].maxlen = 7;
                inputwin[win].lists[13].def = 0;
                strcpy(inputwin[win].lists[13].caption,"Color");

                inputwin[win].lists[13].list_len = 8;
                        strcpy(inputwin[win].lists[13].text[0],"black");
                        strcpy(inputwin[win].lists[13].text[1],"blue");
                        strcpy(inputwin[win].lists[13].text[2],"green");
                        strcpy(inputwin[win].lists[13].text[3],"red");
                        strcpy(inputwin[win].lists[13].text[4],"cyan");
                        strcpy(inputwin[win].lists[13].text[5],"magenta");
                        strcpy(inputwin[win].lists[13].text[6],"brown");
                        strcpy(inputwin[win].lists[13].text[7],"white");

                inputwin[win].lists[14].row = 430;
                inputwin[win].lists[14].col = 130;
                inputwin[win].lists[14].maxlen = 2;
                inputwin[win].lists[14].def = 1;
                strcpy(inputwin[win].lists[14].caption,"Axes: Width");

                inputwin[win].lists[14].list_len = 6;
                        strcpy(inputwin[win].lists[14].text[0],"28");
                        strcpy(inputwin[win].lists[14].text[1],"12");
                        strcpy(inputwin[win].lists[14].text[2],"18");
                        strcpy(inputwin[win].lists[14].text[3],"6");
                        strcpy(inputwin[win].lists[14].text[4],"3");
                        strcpy(inputwin[win].lists[14].text[5],"36");


/*
        COLS form definitions of inputwin structure
*/
        win = COLSWIN;

        inputwin[win].xsize = 330;
        inputwin[win].ysize = 140;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Data Columns");

        inputwin[win].num_inputs = 0;

        inputwin[win].num_buttons = 1;

                inputwin[win].buttons[0].row = 100;
                inputwin[win].buttons[0].col = 175;
                strcpy(inputwin[win].buttons[0].text,"Done");

        inputwin[win].num_lists = 2;

                inputwin[win].lists[0].row = 50;
                inputwin[win].lists[0].col = 180;
                inputwin[win].lists[0].maxlen = 2;
                inputwin[win].lists[0].def = 0;
                strcpy(inputwin[win].lists[0].caption,"Data Column for X:");

                inputwin[win].lists[0].list_len = 5;
                        strcpy(inputwin[win].lists[0].text[0],"1");
                        strcpy(inputwin[win].lists[0].text[1],"2");
                        strcpy(inputwin[win].lists[0].text[2],"3");
                        strcpy(inputwin[win].lists[0].text[3],"4");
                        strcpy(inputwin[win].lists[0].text[4],"5");

                inputwin[win].lists[1].row = 50;
                inputwin[win].lists[1].col = 275;
                inputwin[win].lists[1].maxlen = 2;
                inputwin[win].lists[1].def = 1;
                strcpy(inputwin[win].lists[1].caption,"Y:");

                inputwin[win].lists[1].list_len = 5;
                        strcpy(inputwin[win].lists[1].text[0],"1");
                        strcpy(inputwin[win].lists[1].text[1],"2");
                        strcpy(inputwin[win].lists[1].text[2],"3");
                        strcpy(inputwin[win].lists[1].text[3],"4");
                        strcpy(inputwin[win].lists[1].text[4],"5");
/*
        PROFILE form  definitions of inputwin structure
*/
        win = PROFILEWIN;

        inputwin[win].xsize = 480;
        inputwin[win].ysize = 290;
        inputwin[win].button_width = 70;
        inputwin[win].button_height = 30;
        strcpy(inputwin[win].title,"Profile");

        inputwin[win].num_inputs = 2;

                inputwin[win].inputs[0].row = 150;
                inputwin[win].inputs[0].col = 400;
                inputwin[win].inputs[0].maxlen = 5;
                strcpy(inputwin[win].inputs[0].def,"");
                strcpy(inputwin[win].inputs[0].caption,"Arrow size");

                inputwin[win].inputs[1].row = 200;
                inputwin[win].inputs[1].col = 400;
                inputwin[win].inputs[1].maxlen = 5;
                strcpy(inputwin[win].inputs[1].def,"");
                strcpy(inputwin[win].inputs[1].caption,"Symbol size");

        inputwin[win].num_buttons = 2;

                inputwin[win].buttons[0].row = 250;
                inputwin[win].buttons[0].col = 125;
                strcpy(inputwin[win].buttons[0].text,"Accept");

                inputwin[win].buttons[1].row = 250;
                inputwin[win].buttons[1].col = 350;
                strcpy(inputwin[win].buttons[1].text,"Dismiss");

        inputwin[win].num_lists = 6;

                inputwin[win].lists[0].row = 50;
                inputwin[win].lists[0].col = 250;
                inputwin[win].lists[0].maxlen = 2;
                inputwin[win].lists[0].def = 10;
                inputwin[win].lists[0].numeric = 1;
                strcpy(inputwin[win].lists[0].caption,"Data format: Column width");

                inputwin[win].lists[0].list_len = 20;

                inputwin[win].lists[1].row = 50;
                inputwin[win].lists[1].col = 400;
                inputwin[win].lists[1].maxlen = 2;
                inputwin[win].lists[1].def = 3;
                inputwin[win].lists[1].numeric = 2; /* starting with 0 */
                strcpy(inputwin[win].lists[1].caption,"Invec width");

                inputwin[win].lists[1].list_len = 11;

                inputwin[win].lists[2].row = 100;
                inputwin[win].lists[2].col = 190;
                inputwin[win].lists[2].maxlen = 3;
                inputwin[win].lists[2].def = 1;
                strcpy(inputwin[win].lists[2].caption,"Draw X = 0 line:");

                inputwin[win].lists[2].list_len = 2;
                        strcpy(inputwin[win].lists[2].text[0],"No");
                        strcpy(inputwin[win].lists[2].text[1],"Yes");

                inputwin[win].lists[3].row = 100;
                inputwin[win].lists[3].col = 400;
                inputwin[win].lists[3].maxlen = 3;
                inputwin[win].lists[3].def = 1;
                strcpy(inputwin[win].lists[3].caption,"Draw Y = 0 line:");

                inputwin[win].lists[3].list_len = 2;
                        strcpy(inputwin[win].lists[3].text[0],"No");
                        strcpy(inputwin[win].lists[3].text[1],"Yes");

                inputwin[win].lists[4].row = 150;
                inputwin[win].lists[4].col = 190;
                inputwin[win].lists[4].maxlen = 5;
                inputwin[win].lists[4].def = 0;
                strcpy(inputwin[win].lists[4].caption,"Column delimiter");

                inputwin[win].lists[4].list_len = 4;
                        strcpy(inputwin[win].lists[4].text[0],"none");
                        strcpy(inputwin[win].lists[4].text[1],"comma");
                        strcpy(inputwin[win].lists[4].text[2],"space");
                        strcpy(inputwin[win].lists[4].text[3],"tab");

                inputwin[win].lists[5].row = 200;
                inputwin[win].lists[5].col = 190;
                inputwin[win].lists[5].maxlen = 5;
                inputwin[win].lists[5].def = 1;
                strcpy(inputwin[win].lists[5].caption,"Postscript jointype");

                inputwin[win].lists[5].list_len = 3;
                        strcpy(inputwin[win].lists[5].text[0],"miter");
                        strcpy(inputwin[win].lists[5].text[1],"round");
                        strcpy(inputwin[win].lists[5].text[2],"bevel");
/************
             set text to default values

************/

        for(i=0;i<numwin;i++)
        {
           if(inputwin[i].num_inputs > 0)
           {
           for(j=0;j<inputwin[i].num_inputs;j++)
           {
                strcpy(inputwin[i].inputs[j].text,inputwin[i].inputs[j].def);
           }
           }

           if(inputwin[i].num_lists > 0)
           {
              for(j=0;j<inputwin[i].num_lists;j++)
              {
                  inputwin[i].lists[j].item=inputwin[i].lists[j].def;
              }
           }
        }
}

/****************************************************

        MAIN form routines follow


***************************************************/

put_main_form(int win)
{
/*
        for LPMAIN

        puts variable values for main into inputwin structure

*/

         sprintf(inputwin[win].inputs[0].text,"%s",gf_filename);
         sprintf(inputwin[win].inputs[1].text,"%s",cp_filename);
         sprintf(inputwin[win].inputs[2].text,"%s",cp2_filename);
         sprintf(inputwin[win].inputs[3].text,"%s",set_filename);

         inputwin[win].lists[0].item = ras_type; /* raster type cp/img/cmp */

         inputwin[win].lists[1].item = fade; /* fade between two cp files */

         inputwin[win].lists[2].item = fade_steps-1; /* fade between two cp files */

}

main_disables(int win)
{
/*
        for lpMAIN

        checks if some input boxes should be disabled

*/
         if((inputwin[win].lists[0].item != 1) || (plot_ras == 0) ) /* CP file */
         {
                inputwin[win].inputs[2].disable = 1; /* 2nd cp file */
                inputwin[win].lists[1].disable = 1; /* fade question */
                inputwin[win].lists[1].item=0;/* no fade */
                inputwin[win].lists[2].disable = 1; /* fade steps question */
         }
         else
         {
                inputwin[win].lists[1].disable = 0; /* fade question */

                if(inputwin[win].lists[1].item == 0) /* fade = no */
                {
                       inputwin[win].inputs[2].disable=1;/* 2nd CP file */
                       inputwin[win].lists[2].disable = 1; /* fade steps question */
                }
                else
                {
                       inputwin[win].inputs[2].disable=0;
                       if(plot_cp2 == 1)
                           inputwin[win].lists[2].disable = 0; /* fade steps question */
                }
         }

         if((plot_gf == 1) || (plot_ras == 1))
         {
                inputwin[win].buttons[2].disable = 0; /* plot button */
                inputwin[win].buttons[1].disable = 0; /* rescale button */
         }
         else
         {
                inputwin[win].buttons[2].disable = 1; /* plot button */
                inputwin[win].buttons[1].disable = 1; /* rescale button */
         }

         if(plot_ras == 1)
         {
                inputwin[win].buttons[3].disable = 0; /* zaxis button */
         }
         else
         {
                inputwin[win].buttons[3].disable = 1; /* zaxis button */
         }

         if(strlen(set_filename)>0)
         {
                inputwin[win].buttons[5].disable = 0; /* r/w button */
         }
         else
         {
                inputwin[win].buttons[5].disable = 1; /* r/w button */
         }


}

get_main_form(int win)
{
/*
        for lpMAIN

*/
         strcpy(gf_filename,inputwin[win].inputs[0].text);
         strcpy(cp_filename,inputwin[win].inputs[1].text);
         strcpy(cp2_filename,inputwin[win].inputs[2].text);
         strcpy(set_filename,inputwin[win].inputs[3].text);

         ras_type=inputwin[win].lists[0].item; /* file type */

         fade=inputwin[win].lists[1].item;  /* fade */
         if((fade == 0)||(strlen(cp2_filename)==0))
         {
               plot_cp2=0;
         }

         fade_steps=inputwin[win].lists[2].item+1; /* fade between two cp files */

}

main_form(int *xpos,int *ypos)
{
/*
                LP MAIN form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = MAINWIN; /* window number in the structure */

        put_main_form(win);   /* fill structure with current values */
        main_disables(win); /* check for disables */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

        open_input_window(&my2window,&my2gc,*xpos,*ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = *xpos + inputwin[win].xsize/2;
	ycen = *ypos + inputwin[win].ysize/2;	                           

        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;
                        
                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,xpos,ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(my2window,my2gc,in,win) >= 0 )
                                         {
                                        /* code to do on input change goes next */

                                               get_main_form(win);

                                               if(in == 0) /* gf filename */
                                               {
                                                   get_gf(xcen,ycen);
                                               }
                                               if(in == 1) /* ras filename */
                                               {
                                                    get_ras(xcen,ycen);
                                               }
                                               if(in == 2) /* cp2 filename */
                                               {
                                                    get_cp2(xcen,ycen);
                                               }

                                               main_disables(win);
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */

                                                get_main_form(win);
                                                main_disables(win);
                                                redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Quit button  */
                                           done=yes_no_window(xcen,ycen,"Quit ?",NO);
                                      }

                                      if(q == 1)
                                      {
                                       /* rescale  button  */
                                              rescale_form();
                                      }
                                      if( q == 2)
                                      {
                                      /* plot button */
                                               plot_form();
                                      }
                                      if( q == 3)
                                      {
                                      /* zaxis button */
                                               zaxis_form();
                                      }
                                      if( q == 4)
                                      {
                                      /* profile button */
                                          profile_form();
                                      }
                                      if( q == 5)
                                      {
                                      /* set button */
                                          set_form();
                                      }
                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = yes_no_window(xcen,ycen,"Quit ?",NO);

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

/***********************************************

            SETTINGS form

**************************************************/

set_form()
{
/*
                LP settings form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = SETWIN; /* window number in the structure */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;


                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Read button  */
                                           read_settings(xcen,ycen);
                                           done=1;
                                       }

                                      if(q == 1)
                                      {
                                       /* Write  button  */
                                              write_settings(xcen,ycen);
                                              done=1;
                                      }
                                      if( q == 2)
                                      {
                                      /* Dismiss button */
                                               done = 1;
                                      }
                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = 1;

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

/****************************************************

        ZAXIS form routines follow


***************************************************/

put_zaxis_form(int win)
{
/*
        for zaxis

        puts variable values for main into inputwin structure

*/
        if( zmax==zmin)
        {
                zmax=zmin+1;
                zstep=(zmax-zmin)/5;
        }

         ftoa(inputwin[win].inputs[0].text,"%10g",zmax);
         ftoa(inputwin[win].inputs[1].text,"%10g",zmin);
         ftoa(inputwin[win].inputs[2].text,"%10g",zstep);
         ftoa(inputwin[win].inputs[3].text,"%10g",znull);
         ftoa(inputwin[win].inputs[4].text,"%10g",zbackground);
         ftoa(inputwin[win].inputs[5].text,"%10g",rasinfo.xmax);
         ftoa(inputwin[win].inputs[6].text,"%10g",rasinfo.xmin);
         ftoa(inputwin[win].inputs[7].text,"%10g",rasinfo.ymax);
         ftoa(inputwin[win].inputs[8].text,"%10g",rasinfo.ymin);

         inputwin[win].lists[0].item=plot_zscale;
         inputwin[win].lists[1].item=zback;
         inputwin[win].lists[2].item=colormap;
         inputwin[win].lists[4].item=s3;
         inputwin[win].lists[5].item=zdigits-1;

         strcpy(inputwin[win].inputs[9].text,zlabel);

}

zaxis_disables(int win)
{
float test;
/*
        for lpMAIN

        checks if some input boxes should be disabled

*/
        if(filetype == 1) /* is a cp file */
        {
              inputwin[win].lists[0].disable=0;     /* show z scale ? */
              inputwin[win].lists[1].disable=0;     /* z null color ? */
              inputwin[win].lists[2].disable=0;     /* colormap  */

              if(inputwin[win].lists[0].item == 0)    /* show z scale */
              {
                      inputwin[win].inputs[2].disable=1;    /* z step */
                      inputwin[win].inputs[9].disable=1;    /* zlabel */
                      inputwin[win].lists[5].disable=1;     /* z digits  */
              }
              else
              {
                      inputwin[win].inputs[2].disable=0;
                      inputwin[win].inputs[9].disable=0;
                      inputwin[win].lists[5].disable=0;
              }

              if(inputwin[win].lists[1].item == 0)    /* null white/value */
              {
                      inputwin[win].inputs[4].disable=1;    /* null value */
              }
              else
              {
                      inputwin[win].inputs[4].disable=0;
              }

              inputwin[win].inputs[0].disable=0;    /* z max */
              inputwin[win].inputs[1].disable=0;    /* z min */
              inputwin[win].inputs[2].disable=0;    /* zstep */
              inputwin[win].inputs[3].disable=0;    /* z null */
              inputwin[win].inputs[5].noedit=1;    /* x max */
              inputwin[win].inputs[6].noedit=1;    /* x min */
              inputwin[win].inputs[7].noedit=1;    /* y max */
              inputwin[win].inputs[8].noedit=1;    /* y min */
              inputwin[win].lists[3].disable=1;    /* preserve aspect */

              if( (atof(inputwin[win].inputs[0].text)*atof(inputwin[win].inputs[1].text)) > 0.0) /* can do log */
              {
                      inputwin[win].lists[4].disable=0; /* log z scale */
              }
              else
              {
                      inputwin[win].lists[4].disable=1; /* log z scale */
                      inputwin[win].lists[4].item=0; /* set back to N */
              }

              test = fabs(atof(inputwin[win].inputs[0].text)-atof(inputwin[win].inputs[1].text));
              if(atof(inputwin[win].inputs[2].text) >= (test/2.))
              {
                   ftoa(inputwin[win].inputs[2].text,"%10g",test/10.);
              }
        }
        else
        {
              inputwin[win].inputs[2].disable=1;    /* z step */
              inputwin[win].inputs[9].disable=1;    /* zlabel */
              inputwin[win].inputs[4].disable=1;    /* null value */
              inputwin[win].lists[0].disable=1;     /* show z scale ? */
              inputwin[win].lists[1].disable=1;     /* z null color ? */
              inputwin[win].lists[2].disable=1;     /* colormap  */
              inputwin[win].lists[5].disable=1;     /* z digits  */

              inputwin[win].inputs[0].disable=1;    /* z max */
              inputwin[win].inputs[1].disable=1;    /* z min */
              inputwin[win].inputs[2].disable=1;    /* zstep */
              inputwin[win].inputs[3].disable=1;    /* z null */
              inputwin[win].inputs[5].noedit=0;    /* x max */
              inputwin[win].inputs[6].noedit=0;    /* x min */
              inputwin[win].inputs[7].noedit=0;    /* y max */
              inputwin[win].inputs[8].noedit=0;    /* y min */
              inputwin[win].lists[3].disable=0;    /* preserve aspect */

              inputwin[win].lists[4].disable=1; /* log z scale */
              inputwin[win].lists[4].item=0; /* set back to N */
        }


}

zaxis_aspect(int win,int chng)
{

        if(inputwin[win].lists[3].item == 1) /* preserve = yes */
        {
                if(chng == 5) /* x max --> y max  (size) */
                {
                        rasinfo.ymax = rasinfo.ymin + (rasinfo.xmax-rasinfo.xmin)/aspect_ratio;
                }
                if(chng == 6) /* x min -- > x max (translation)  */
                {
                        rasinfo.xmax = rasinfo.xmin + (rasinfo.ymax-rasinfo.ymin)*aspect_ratio;
                }
                if(chng == 7) /* y max --> x max (size) */
                {
                        rasinfo.xmax = rasinfo.xmin + (rasinfo.ymax-rasinfo.ymin)*aspect_ratio;
                }
                if(chng == 8) /* y min -- > y max (translation)  */
                {
                        rasinfo.ymax = rasinfo.ymin + (rasinfo.xmax-rasinfo.xmin)/aspect_ratio;
                }

        }

}

get_zaxis_form(int win)
{
/*
        for lp zaxis

*/
         zmax=atof(inputwin[win].inputs[0].text);
         zmin=atof(inputwin[win].inputs[1].text);
         zstep=atof(inputwin[win].inputs[2].text);
         znull=atof(inputwin[win].inputs[3].text);
         zbackground=atof(inputwin[win].inputs[4].text);
         rasinfo.xmax=atof(inputwin[win].inputs[5].text);
         rasinfo.xmin=atof(inputwin[win].inputs[6].text);
         rasinfo.ymax=atof(inputwin[win].inputs[7].text);
         rasinfo.ymin=atof(inputwin[win].inputs[8].text);

         plot_zscale=inputwin[win].lists[0].item;
         zback=inputwin[win].lists[1].item;
         colormap=inputwin[win].lists[2].item;
         s3=inputwin[win].lists[4].item;
         zdigits=inputwin[win].lists[5].item+1;

         strcpy(zlabel,inputwin[win].inputs[9].text);

}

zaxis_form()
{
/*
                LP ZAXIS form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = ZAXISWIN; /* window number in the structure */

        put_zaxis_form(win);   /* fill structure with current values */
        zaxis_disables(win); /* check for disables */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(my2window,my2gc,in,win) >= 0 )
                                         {
                                        /* code to do on input change goes next */

                                               zaxis_disables(win);
                                               get_zaxis_form(win);
                                               zaxis_aspect(win,in);
                                               put_zaxis_form(win);
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */

                                                zaxis_disables(win);
                                                redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* dismiss button  */
                                           get_zaxis_form(win);
                                           done=1;
                                      }
                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( (mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                        get_zaxis_form(win);
                                        done = 1;
                                }

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

/*****************************************************************

        PLOT form routines follow

   ******* HPGL disabled ********

        new variables:
                plot_curves
                plot_axes
                plot_comments
                plotfile

                seg_color[]     for data segments
                seg_width[]
                seg_pattern[]
                seg_pat_len[]

                text_font[]   0 = axes lables font
                text_color[]  0 = black

                x_plot_size
                y_plot_size
                plot_device

        old variables:
                vp
                rotp
                encap

        need to add:
                preview button with ghostview call
                checks for too many comments or data segments



********************************************************/

put_plot_form(int win)
{
int k,i;

         strcpy(inputwin[win].inputs[0].text,plotfile);
         ftoa(inputwin[win].inputs[1].text,"%5g",vp);
         ftoa(inputwin[win].inputs[2].text,"%5g",x_plot_size);
         ftoa(inputwin[win].inputs[3].text,"%5g",y_plot_size);

         if( plot_device == 3)
         {
               if( encap == 0) inputwin[win].lists[0].item = 0; /* PS output */
               if( encap == 1) inputwin[win].lists[0].item = 1; /* encap PS output */
         }
         else
         {
               inputwin[win].lists[0].item = 2; /* HPGL output */
         }

         if((rotp == 'y' )||(rotp == 'Y'))
         {
               inputwin[win].lists[1].item = 0; /* portrait */
         }
         else
         {
               inputwin[win].lists[1].item = 1; /* landscape */
         }

         inputwin[win].lists[2].item = plot_axes; /* 1 = yes 0 = no */
         inputwin[win].lists[3].item = plot_comments; /* 1 = yes 0 = no */
         inputwin[win].lists[4].item = plot_curves; /* 1 = yes 0 = no */
}

plot_lists_coord(int win,int list)
{
int text,seg;
        if(list == 5)
        {
         seg=inputwin[win].lists[5].item; /* get segment from its list */

         inputwin[win].lists[6].item = seg_color[seg]; /* set color */
         inputwin[win].lists[7].item = seg_width[seg]; /* set width */
         inputwin[win].lists[8].item = seg_pattern[seg]; /* set pattern */
         inputwin[win].lists[9].item = seg_pat_len[seg]; /* set pattern length */
        }
        if(list == 10)
        {
         text=inputwin[win].lists[10].item;
         inputwin[win].lists[11].item=text_font[text]; /* set font for text */
         inputwin[win].lists[12].item=text_color[text]; /* set color for text */
        }
}

plot_lists_defaults(int win)
{
int i,j,k;
           if(inputwin[win].num_lists > 0)
           {
           for(j=0;j<inputwin[win].num_lists;j++)
           {
                inputwin[win].lists[j].item=inputwin[win].lists[j].def;
           }
           }

           k = num_data_segments();
           if(k > 0)
           {
                inputwin[win].lists[5].list_len = k;

                for(i=0;i<k;i++)
                {
                     seg_color[i] = inputwin[win].lists[6].def; /* black */
                     seg_width[i] = inputwin[win].lists[7].def; /* 12 */
                     seg_pattern[i] = inputwin[win].lists[8].def; /* solid */
                     seg_pat_len[i] = inputwin[win].lists[9].def; /* 4 */
                }
           }

           axes_color=inputwin[win].lists[13].def; /* black */
           axes_color=inputwin[win].lists[14].def; /* 12 */

           /*
              text_font[0] refers to the axes labels.
           */

           for(i=0;i<=num_comments;i++)
           {
                text_font[i]=inputwin[win].lists[11].def; /* 2 */
                text_color[i]=inputwin[win].lists[12].def; /* black */
           }

           for(i=1;i<=num_comments;i++)
           {
                  strncpy(inputwin[win].lists[10].text[i],comments[i-1],20);
           }
           inputwin[win].lists[10].list_len = num_comments + 1;

           if(strstr(filecurrent,"+") == NULL)
           {
                strcpy(plotfile,filecurrent);
                if(strstr(plotfile,".") != NULL)
                {
                   *strstr(plotfile,".")='\0';
                }
           }
           else
                strcpy(plotfile,"temp");
}

plot_disables(int win)
{

        if( inputwin[win].lists[0].item == 2 ) /* HPGL */
        {
                inputwin[win].lists[10].disable = 1;
                inputwin[win].lists[11].disable = 1;
                inputwin[win].lists[12].disable = 1;
        }
        else
        {
                inputwin[win].lists[10].disable = 0;
                inputwin[win].lists[11].disable = 0;
                inputwin[win].lists[12].disable = 0;
        }

        if( inputwin[win].lists[4].item == 0 ) /* no curve */
        {
                inputwin[win].lists[5].disable = 1;
                inputwin[win].lists[6].disable = 1;
                inputwin[win].lists[7].disable = 1;
                inputwin[win].lists[8].disable = 1;
                inputwin[win].lists[9].disable = 1;
        }
        else
        {
                inputwin[win].lists[5].disable = 0;
                inputwin[win].lists[6].disable = 0;
                inputwin[win].lists[7].disable = 0;
                inputwin[win].lists[8].disable = 0;
                inputwin[win].lists[9].disable = 0;
        }

        if(num_comments == 0)
        {
                inputwin[win].lists[3].disable == 1; /* no comments */
        }
        else
        {
                inputwin[win].lists[3].disable == 0;
        }

        if((inputwin[win].lists[3].item == 0)||(num_comments == 0)) /* no comments one way or another */
        {
            if(inputwin[win].lists[2].item == 1) /* plot axes == yes */
            {
                inputwin[win].lists[10].list_len = 1; /* axis labels only */
                inputwin[win].lists[10].item = 0;
                inputwin[win].lists[10].disable = 0;
                inputwin[win].lists[11].disable = 0;
                inputwin[win].lists[12].disable = 0;
            }
            else
            {
                inputwin[win].lists[10].disable = 1; /* don't need at all */
                inputwin[win].lists[11].disable = 1;
                inputwin[win].lists[12].disable = 1;
            }
        }
        else
        {
                inputwin[win].lists[10].list_len = num_comments+1;
                inputwin[win].lists[10].disable = 0;
                inputwin[win].lists[11].disable = 0;
                inputwin[win].lists[12].disable = 0;
        }

        if(inputwin[win].lists[2].item == 1) /* plot axes == yes */
        {
                inputwin[win].lists[13].disable=0; /* axis color */
                inputwin[win].lists[14].disable=0; /* axis width */
        }
        else
        {
                inputwin[win].lists[13].disable=1; /* axis color */
                inputwin[win].lists[14].disable=1; /* axis width */
        }

        if(plot_ras == 1) /* we have a raster file */
        {
             inputwin[win].inputs[3].disable=1;/* fixed aspect if have ras file */
        }
        else
        {
             inputwin[win].inputs[3].disable=0;
        }
}

get_plot_form(int win)
{
int i,k;
         strcpy(plotfile,inputwin[win].inputs[0].text);
         vp=atof(inputwin[win].inputs[1].text);
         x_plot_size=atof(inputwin[win].inputs[2].text);
         y_plot_size=atof(inputwin[win].inputs[3].text);
         axes_color=inputwin[win].lists[13].item;
         axes_width=inputwin[win].lists[14].item;

         if(inputwin[win].lists[0].item == 0) /* PS output */
         {
                plot_device = 3;
                encap = 0;
         }
         if(inputwin[win].lists[0].item == 1) /* encap PS output */
         {
                plot_device = 3;
                encap = 1;
         }

         if(inputwin[win].lists[1].item == 0) /* portrait */
         {
                rotp = 'y';
         }
         else
         {
                rotp = 'n';
         }

         plot_axes = inputwin[win].lists[2].item; /* 1 = yes 0 = no */
         plot_comments = inputwin[win].lists[3].item; /* 1 = yes 0 = no */
         plot_curves = inputwin[win].lists[4].item ; /* 1 = yes 0 = no */

           i = inputwin[win].lists[5].item;
                seg_color[i] = inputwin[win].lists[6].item;
                seg_width[i] = inputwin[win].lists[7].item;
                seg_pattern[i] = inputwin[win].lists[8].item;
                seg_pat_len[i] = inputwin[win].lists[9].item;

           /*
              text_font[0] refers to the axes labels.
           */

           i = inputwin[win].lists[10].item;
                text_font[i]=inputwin[win].lists[11].item;
                text_color[i]=inputwin[win].lists[12].item;

}

plot_form()
{
/*
                GF PLOT form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                returns the button pressed and the updated text (in place)
                      and the updated list items

                includes event loop with redraw and resize

                needs the redraw for the main window added.

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = PLOTWIN; /* window number in the structure */

        put_plot_form(win);   /* fill structure with current values */
        plot_disables(win); /* check for disables */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(my2window,my2gc,in,win) >= 0 )
                                         {
                                        /* code to do on input change goes next */
                                               plot_disables(win);
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */
                                                plot_lists_coord(win,in);
                                                get_plot_form(win);
                                                plot_disables(win);
                                                redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Plot button  */
                                           get_plot_form(win);
                                           plot_disables(win);
                                           plot(xcen,ycen);
                                      }

                                      if(q == 1)
                                      {
                                       /* Dismiss button  */
                                           get_plot_form(win);
                                           done =2;

                                      }

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = 2;

                                if( (mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                /* defaults ...  */
                                     get_plot_form(win);
                                     plot_disables(win);
                                     plot(xcen,ycen);
                                }

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

/****************************************************

        RESCALE form routines follow


***************************************************/

put_rescale_form(int win)
{
/*
        for RESCALE

        puts variable values for scaling into inputwin structure

*/

         ftoa(inputwin[win].inputs[0].text,"%10g",xmax);
         ftoa(inputwin[win].inputs[1].text,"%10g",xmin);
         ftoa(inputwin[win].inputs[2].text,"%10g",ymax);
         ftoa(inputwin[win].inputs[3].text,"%10g",ymin);
         sprintf(inputwin[win].inputs[4].text,"%s",xlabel);
         sprintf(inputwin[win].inputs[5].text,"%s",ylabel);
         ftoa(inputwin[win].inputs[6].text,"%10g",xtick);
         ftoa(inputwin[win].inputs[7].text,"%10g",ytick);

         inputwin[win].lists[0].item = s1; /* x lin/log 0/1 */

         inputwin[win].lists[1].item = s2;

         if((ticks == 'n') || (ticks == 'N') )
         {
             inputwin[win].lists[2].item = 0;
         }
         if((ticks == 't') || (ticks == 'T'))
         {
             inputwin[win].lists[2].item = 1;
         }
         if((ticks == 'g') || (ticks == 'G') )
         {
             inputwin[win].lists[2].item = 2;
         }

}

rescale_disables(int win)
{
/*
        for RESCALE

        checks if some input boxes should be disabled

*/
float xmax1,xmin1,ymax1,ymin1;

         xmax1=atof(inputwin[win].inputs[0].text);
         xmin1=atof(inputwin[win].inputs[1].text);
         if(xmax1 == xmin1 )
         {
                xmax1=xmin1+1;
         }

         ymax1=atof(inputwin[win].inputs[2].text);
         ymin1=atof(inputwin[win].inputs[3].text);
         if(ymax1 == ymin1 )
         {
                ymax1=ymin1+1;
         }


         if( (xmax1*xmin1 <= 0.)||(plot_ras == 1) )
         {
               inputwin[win].lists[0].disable = 1;
               inputwin[win].lists[0].item = 0; /* x lin/log 0/1 */
         }
         else
         {
               inputwin[win].lists[0].disable = 0;
         }

         if( (ymax1*ymin1 <= 0.)||(plot_ras == 1) )
         {
               inputwin[win].lists[1].disable = 1;
               inputwin[win].lists[1].item = 0; /* x lin/log 0/1 */
         }
         else
         {
               inputwin[win].lists[1].disable = 0;
         }


         if(inputwin[win].lists[2].item == 0)
         {
             inputwin[win].inputs[6].disable = 1;
             inputwin[win].inputs[7].disable = 1;
         }
         if(inputwin[win].lists[2].item == 1)
         {
             inputwin[win].inputs[6].disable = 0;
             inputwin[win].inputs[7].disable = 0;
         }
         if(inputwin[win].lists[2].item == 2)
         {
             inputwin[win].inputs[6].disable = 0;
             inputwin[win].inputs[7].disable = 0;
         }

         inputwin[win].buttons[0].disable=1; /* apply button -- don't need */

}

get_rescale_form(int win,int x,int y)
{
/*
        for RESCALE

        gets the variable values out of the inputwin structure

        prompts on error

        updates the structure values if variables changed due to error

*/
         xmax=atof(inputwin[win].inputs[0].text);
         xmin=atof(inputwin[win].inputs[1].text);
         if(xmax == xmin )
         {
                info_window(x,y,"X max cannot equal X min");
                xmax=xmin+1;
         }

         ymax=atof(inputwin[win].inputs[2].text);
         ymin=atof(inputwin[win].inputs[3].text);
         if(ymax == ymin )
         {
                info_window(x,y,"Y max cannot equal Y min");
                ymax=ymin+1;
         }

         strcpy(xlabel,inputwin[win].inputs[4].text);
         strcpy(ylabel,inputwin[win].inputs[5].text);
         xtick=atof(inputwin[win].inputs[6].text);
         ytick=atof(inputwin[win].inputs[7].text);

         s1=inputwin[win].lists[0].item; /* x lin/log 0/1 */

         s2=inputwin[win].lists[1].item;

         if(inputwin[win].lists[2].item == 0) ticks = 'n';
         if(inputwin[win].lists[2].item == 1) ticks = 't';
         if(inputwin[win].lists[2].item == 2) ticks = 'g';

         if( ticks != 'n')
         {
             if(xtick <= 0.)
             {
                info_window(x,y,"X tick zero or negative");
                xtick = fabs((xmax-xmin)/10.);
             }
             if(ytick <= 0.)
             {
                info_window(x,y,"Y tick zero or negative");
                ytick = fabs((ymax-ymin)/10.);
             }
         }

         put_rescale_form(win); /*  changed values back into form */

}

rescale_form()
{
/*
                GF RESCALE form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                includes event loop with redraw and resize (inc main window)

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = RESCALEWIN; /* window number in the structure */

        put_rescale_form(win);   /* fill structure with current values */
        rescale_disables(win); /* check for disables */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(my2window,my2gc,in,win) >= 0 )
                                         {
                                        /* code to do on input change goes next */
                                               rescale_disables(win);
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */

                                                rescale_disables(win);
                                                redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Apply button  */
                                           get_rescale_form(win,xcen,ycen);
                                           rescale_disables(win);
                                      }

                                      if(q == 1)
                                      {
                                       /* Dismiss button  */
                                           get_rescale_form(win,xcen,ycen);
                                           rescale_disables(win);
                                           done =1;
                                      }
                                      if( q == 2)
                                      {
                                      /* Auto Button */
                                         if(plot_gf == 1)
                                         {
                                             maxmin(&xx1,&xx2,&yy1,&yy2);
                                             xmax=xx2;
                                             xmin=xx1;
                                             ymax=yy2;
                                             ymin=yy1;
                                         }
                                         else
                                         {
                                             xmax=rasinfo.xmax;
                                             xmin=rasinfo.xmin;
                                             ymax=rasinfo.ymax;
                                             ymin=rasinfo.ymin;
                                         }
                                          s1=0;
                                          s2=0;
                                          ticks= 'n';
                                          xtick = fabs(xmax-xmin)/10.;
                                          ytick = fabs(ymax-ymin)/10.;

                                          put_rescale_form(win);
                                          rescale_disables(win);
                                          redraw_inwin(my2window,my2gc,win);
                                      }

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = 1;

                                if( (mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                /* defaults ...  */
                                     get_rescale_form(win,xcen,ycen);
                                     rescale_disables(win);
                                }

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

/***********************************************


        COLS form : ask number of data columns


***********************************************/


cols_form(int *xc,int *yc,int maxcols)
{
/*
                GF COLS form: Number of data cols to use for X and Y

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                includes event loop with redraw and resize (inc main window)

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

                returns the xcol and ycol selected

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = COLSWIN; /* window number in the structure */

        put_cols_form(win,maxcols);   /* fill structure with current values */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */

            XNextEvent(mydisplay, &my2event);

            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;


                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */
                                           redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Done button  */
                                           get_cols_form(win,xc,yc);
                                           if( *xc == *yc)
                                           {
                                                info_window(xcen,ycen,"Can't have both axes the same");
                                           }
                                           else
                                           {
                                                done = 1;
                                           }
                                      }

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if((mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                       get_cols_form(win,xc,yc);
                                       if( *xc == *yc)
                                       {
                                            info_window(xcen,ycen,"Can't have both columns the same");
                                       }
                                       else
                                       {
                                            done = 1;
                                       }
                                }

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}


put_cols_form(int win,int maxcols)
{
int i;
        for(i=0;i<maxcols;i++)
        {
               sprintf(inputwin[win].lists[0].text[i],"%2i",i+1);
               sprintf(inputwin[win].lists[1].text[i],"%2i",i+1);
        }
        inputwin[win].lists[0].list_len = maxcols;
        inputwin[win].lists[1].list_len = maxcols;
        inputwin[win].lists[0].item = 0;
        inputwin[win].lists[1].item = 1;
}

get_cols_form(int win,int *xc,int *yc)
{

        *xc=atoi(inputwin[win].lists[0].text[inputwin[win].lists[0].item]);
        *yc=atoi(inputwin[win].lists[1].text[inputwin[win].lists[1].item]);

}


/********************************************************

        PROFILE form

*********************************************************/


profile_form()
{
/*
                GF PROFILE form

                opens a second window for input using inputwin structure

                draws buttons and text input/list boxes

                changes the variables as requested

                includes event loop with redraw and resize (inc main window)

                could add keyboard short cuts

                uses redraw_inwin() for its window redraw

*/

int done,i,in,q,win,xcen,ycen;
int col,row;
char txt[20];
float xx1,xx2,yy1,yy2;

/* declarations for second window  */
static int xpos = -1; /* position of this window */
static int ypos = -1;

Window my2window;
GC my2gc;
XEvent my2event;
XSizeHints my2hint;

        win = PROFILEWIN; /* window number in the structure */

        put_profile_form(win);   /* fill structure with current values */
/*
        open_input_window(&my2window,&my2gc,&my2hint,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);
*/

	if( xpos == -1 && ypos == -1)
	{
		xpos = main_xpos + inputwin[MAINWIN].xsize/2 - inputwin[win].xsize/2;
		ypos = main_ypos + inputwin[MAINWIN].ysize/2 - inputwin[win].ysize/2;
	}

        open_input_window(&my2window,&my2gc,xpos,ypos,inputwin[win].xsize,
                           inputwin[win].ysize,inputwin[win].title);

        /* save the center for later window opens */                   
	xcen = xpos + inputwin[win].xsize/2;
	ycen = ypos + inputwin[win].ysize/2;	                           


        /* event-reading loop to get input */
        done = 0;
        while( done == 0) {
            /* read the next event */
            XNextEvent(mydisplay, &my2event);
            /* events for input window */
            if(my2event.xany.window == my2window)
            {
                switch(my2event.type){
                        /* repaint window on expose events */
                        case Expose:

                              if(my2event.xexpose.count == 0)
                                        redraw_inwin(my2window,my2gc,win);

                        break;

                        /* keep track of window position */
                        case ConfigureNotify:
                        	save_center(my2event,&xcen,&ycen,&xpos,&ypos);
                        break;

                        case LeaveNotify:
                        /*
                               redraw_inwin(my2window,my2gc,win);
                               q = -1;
                               */
                        break;

                        case MotionNotify:
                                if(q != -1)
                                {
                                        if(q != which_button(my2event.xmotion.x,my2event.xmotion.y,win) )
                                        {
                                             redraw_inwin(my2window,my2gc,win);
                                             q = -1;
                                        }
                                  }
                        break;

                        /* process keyboard mapping changes */
                        case MappingNotify:
                               XRefreshKeyboardMapping(&my2event.xmapping);
                        break;

                        /* process mouse-button presses */
                        case ButtonPress:

                                    col=my2event.xmotion.x;
                                    row=my2event.xmotion.y;

                                    /* check input boxes */

                                    in = check_input(win,row,col);
                                    if( in > -1 )
                                    {
                                         if(get_input(my2window,my2gc,in,win) >= 0 )
                                         {
                                           /* code to do on input change goes next */
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                          else
                                          {
                                               redraw_inwin(my2window,my2gc,win);
                                          }
                                      }

                                      /* check list arrows */

                                      in = check_list(win,row,col);
                                      if( in > -1 )
                                      {
                                     /* code to do on list change goes next */
                                                profile_disables(win);
                                                redraw_inwin(my2window,my2gc,win);
                                      }

                                      q=check_button(my2window,my2gc,col,row,win);

                                      if(q == 0)
                                      {
                                       /* Accept button  */
                                           get_profile_form(win);
                                           done = 1;
                                      }

                                      if(q == 1)
                                      {
                                       /* Dismiss button  */
                                           done =1;
                                      }

                        break;

                        /* process keyboard input */
                        case KeyPress:
                                i = XLookupString( &my2event.xkey, txt, 10, &mykey, 0);
                                /* if form key pressed code is needed it goes next */

                                if( mykey == XK_Escape ) done = 1;

                                if( (mykey == XK_Return) || (mykey == XK_KP_Enter) || (mykey == XK_Linefeed))
                                {
                                /* defaults ...  */
                                     get_profile_form(win);
                                     done = 1;
                                }

                        break;
                } /* switch(my2event.type) */
            } /* if my window */
        } /* while(done == 0) */

        close_input_window(my2window,my2gc);

        return(done);
}

profile_disables(int win)
{
/* don't need vlen and dlen if using delimiter */

        if( inputwin[win].lists[4].item == 0) /* delim = none */
        {
                inputwin[win].lists[0].disable = 0; /* dlen */
                inputwin[win].lists[1].disable = 0; /* vlen */
        }
        else
        {
                inputwin[win].lists[0].disable = 1; /* dlen */
                inputwin[win].lists[1].disable = 1; /* vlen */
        }

/* don't let dlen be less than 7 */

        if(inputwin[win].lists[0].item < 6 )
        {
                inputwin[win].lists[0].item = 6;
        }
}

put_profile_form(int win)
{
        inputwin[win].lists[0].item = dlen -1;
        inputwin[win].lists[1].item = vlen;

        if((xzero == 'y')||(xzero =='Y'))
        {
                inputwin[win].lists[2].item = 1;
        }
        else
        {
                inputwin[win].lists[2].item = 0;
        }

        if((yzero == 'y')||(yzero =='Y'))
        {
                inputwin[win].lists[3].item = 1;
        }
        else
        {
                inputwin[win].lists[3].item = 0;
        }

        if( use_delim == 1 ) /* use delimiter on data read */
        {
                if( delim_char == ',')
                        inputwin[win].lists[4].item=1;
                if( delim_char == ' ')
                        inputwin[win].lists[4].item=2;
                if( delim_char == '\t')
                        inputwin[win].lists[4].item=3;
        }
        else
        {
               inputwin[win].lists[4].item=0;
        }

        inputwin[win].lists[5].item=psjoin;

        ftoa(inputwin[win].inputs[0].text,"%5g",arrow_size);
        ftoa(inputwin[win].inputs[1].text,"%5g",symbol_scale);

}

get_profile_form(int win)
{
        if(inputwin[win].lists[4].item == 0)
        {
             dlen=inputwin[win].lists[0].item +1;
             vlen=inputwin[win].lists[1].item ; /* zero is ok */
        }
        else
        {
             dlen=10;   /* defaults for scaling if using delim */
             vlen=3;
        }

        if(inputwin[win].lists[2].item == 1)
                xzero = 'y';
        else
                xzero = 'n';

        if(inputwin[win].lists[3].item == 1)
                yzero = 'y';
        else
                yzero = 'n';

        if(inputwin[win].lists[4].item == 0)
        {
                use_delim = 0 ;
        }
        if(inputwin[win].lists[4].item == 1)
        {
                use_delim = 1;
                delim_char = ',';
        }
        if(inputwin[win].lists[4].item == 2)
        {
                use_delim = 1;
                delim_char = ' ';
        }
        if(inputwin[win].lists[4].item == 3)
        {
                use_delim = 1;
                delim_char = '\t';
        }

        psjoin=inputwin[win].lists[5].item;

        arrow_size=atof(inputwin[win].inputs[0].text);
        symbol_scale=atof(inputwin[win].inputs[1].text);

}

/***********************************************************************

	common routines
	
************************************************************************/

save_center(XEvent myevent,int *xc,int *yc,int *xpos,int *ypos)
{
/*
	on configure notify event for input windows
	returns the center if it moved (these can't be resized)
	
	also returns the position corrected for WM border
*/
int xt,yt,xs,ys;	
	xs = myevent.xconfigure.width;
	ys = myevent.xconfigure.height;
	
	xt = myevent.xconfigure.x;
	yt = myevent.xconfigure.y;
	if(xt != 0 && yt != 0)
	{
		*xc=xt + xs/2;
		*yc=yt + ys/2;
                *xpos = xt - WM_BORDER_WIDTH;
                *ypos = yt - WM_TITLEBAR_HEIGHT;
	}
	
        if(debug)
        {
        	printf("save center: center at %i,%i\n",*xc,*yc);
        	printf("save center: at %i %i size = %ix%i \n",xt,yt,xs,ys);
        }
}
